<?php

namespace Drupal\bazaarvoice_productfeed\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Url;
use Drupal\Core\Link;

/**
 * Class AttributesListForm.
 *
 * @package Drupal\bazaarvoice_productfeed\Form
 */
class AttributesListForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'bazaarvoice_productfeed_attributes_list_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {

    module_load_include('inc', 'bazaarvoice_productfeed', 'includes/attributes');

    $table = array(
      '#theme' => 'table',
      '#header' => array(
        array('data' => t('Attribute')),
        array('data' => t('Operations'), 'colspan' => 2),
      ),
      '#rows' => array(),
    );

    // Fetch attributes from code.
    if ($attributes = bazaarvoice_productfeed_get_custom_attributes()) {
      foreach ($attributes as $name => $attribute) {
        $table['#rows'][] = array(
          array('data' => $attribute['label'] . ' (' . $name . ')'),
          array('data' => Link::fromTextAndUrl(t('Edit'), Url::fromUri('internal:/admin/config/services/bazaarvoice/productfeed/attributes/edit/' . $name))),
          array('data' => Link::fromTextAndUrl(t('Delete'), Url::fromUri('internal:/admin/config/services/bazaarvoice/productfeed/attributes/delete/' . $name))),
        );
      }
    }
    $table['#rows'][] = array(
      array(
        'data' => Link::fromTextAndUrl(t('Add Custom Attribute'), Url::fromUri('internal:/admin/config/services/bazaarvoice/productfeed/attributes/add')),
        'colspan' => 3,
      ),
    );

    return $table;
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    parent::validateForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);
  }

}
