<?php

namespace Drupal\bazaarvoice_productfeed\ParamConverter;

use Drupal\Core\ParamConverter\ParamConverterInterface;
use Symfony\Component\Routing\Route;
use Drupal\Core\Database\Database;

/**
 * Parameter converter for upcasting attributes to arrays.
 */
class BazaarvoiceProductfeedParamConverter implements ParamConverterInterface {

  /**
   * {@inheritdoc}
   */
  public function convert($value, $definition, $name, array $defaults) {
    $attribute = [];
    if ($value) {
      $connection = Database::getConnection();

      $id_exists = $connection
        ->select('bazaarvoice_productfeed_custom_attributes', 'bpfca')
        ->condition('attribute', $value)
        ->countQuery()
        ->execute()->fetchField();

      // Id already exists in the Database?
      if ($id_exists) {
        $attribute = $connection
          ->select('bazaarvoice_productfeed_custom_attributes', 'bpfca')
          ->fields('bpfca')
          ->condition('attribute', $value)
          ->execute()->fetch(\PDO::FETCH_ASSOC);
      }
    }
    return $attribute;
  }

  /**
   * {@inheritdoc}
   */
  public function applies($definition, $name, Route $route) {
    return (!empty($definition['type']) && $definition['type'] == 'bv_attribute');
  }

}
