<?php

namespace Drupal\bazaarvoice_products\Plugin\Block;

use Drupal\Core\Block\BlockBase;

/**
 * Provides a 'Product Statistics' Block.
 *
 * @Block(
 *   id = "bazaarvoice_product_statistics",
 *   admin_label = @Translation("Bazaarvoice: Product Statistics"),
 * )
 */
class BazaarvoiceProductsBlock extends BlockBase {

  /**
   * {@inheritdoc}
   */
  public function build() {
    $block = [];

    // User have permissions to view statistics and have an entity?
    // @FIXME.
    $entity = \Drupal::routeMatch()->getParameter('node');

    if (\Drupal::currentUser()
        ->hasPermission('view bazaarvoice product statistics') && ($entity)
    ) {
      // Attempt to get known entity type.
      if ($entity_type = bazaarvoice_products_get_entity_bundle_entity_type($entity->type)) {
        // Attempt to get product statistics.
        module_load_include('inc', 'bazaarvoice_products', 'includes/statistics');
        if ($product_statistics = bazaarvoice_products_view_product_statistics($entity_type, $entity)) {
          $block['subject'] = t('Product Statistics');
          $block['content']['#markup'] = $product_statistics;
        }
      }
    }
    return $block;
  }

}
