<?php

namespace Drupal\bazaarvoice_reviews\Plugin\Block;

use Drupal\Core\Block\BlockBase;

/**
 * Provides a 'Product Statistics' Block.
 *
 * @Block(
 *   id = "bazaarvoice_reviews",
 *   admin_label = @Translation("Bazaarvoice: Product Reviews"),
 * )
 */
class BazaarvoiceReviewsBlock extends BlockBase {

  /**
   * {@inheritdoc}
   */
  public function build() {
    $block = [];
    // User have permissions to view statistics and have an entity?
    // @FIXME.
    // User can view reviews && page has an entity?
    $entity = \Drupal::routeMatch()->getParameter('node');

    if (\Drupal::currentUser()
        ->hasPermission('view bazaarvoice reviews') && (isset($entity))
    ) {
      module_load_include('module', 'bazaarvoice_products');
      // Attempt to get known entity type.
      if ($entity_type = bazaarvoice_products_get_entity_bundle_entity_type($entity->type)) {
        module_load_include('inc', 'bazaarvoice_reviews', 'includes/reviews');
        // Get reviews.
        // @TODO: different function for different template.
        if ($reviews = bazaarvoice_reviews_view_reviews($entity_type, $entity)) {
          $block['subject'] = t('Product Reviews');
          $block['content']['#markup'] = $reviews;
        }
      }
    }
    return $block;
  }

}
