<?php

namespace Drupal\bazaarvoice_reviews\Routing;

/**
 * @file
 * Contains \Drupal\bazaarvoice_reviews\EventSubscriber\RouteSubscriber.
 */

use Symfony\Component\Routing\Route;

/**
 * Provides routes for product entities that can be reviewed.
 */
class BazaarvoiceReviewsRouteProvider {

  /**
   * {@inheritdoc}
   */
  public function routes() {
    $routes = [];
    $write_review_uri = bazaarvoice_reviews_get_write_a_review_uri();
    $view_reviews_uri = bazaarvoice_reviews_get_reviews_uri();

    $routes['bazaarvoice_reviews.entity.add_review'] = new Route(// Path to attach this route to:
      '/node/{node}' . $write_review_uri,
      // Route defaults:
      array(
        '_controller' => '\Drupal\bazaarvoice_reviews\Controller\BazaarvoiceReviewsAddReviewController::newReview',
        '_title' => 'Add Review',
        // '_title_callback' => '\Drupal\bazaarvoice_reviews\Controller\BazaarvoiceReviewsAddReviewForm::title',
      ), // Route requirements:
      array(
        '_permission' => 'access content',
        'node' => '\d+',
      ), array(
        'parameters' => array(
          'node' => array(
            'type' => 'bv_product_node',
          ),
        ),
      ));
    $routes['bazaarvoice_reviews.entity.bv_view_reviews'] = new Route(// Path to attach this route to:
      '/node/{node}' . $view_reviews_uri,
      // Route defaults:
      array(
        '_controller' => '\Drupal\bazaarvoice_reviews\Controller\BazaarvoiceReviewsViewReviewsController::view',
        '_title' => 'View Reviews',
        // '_title_callback' => '\Drupal\bazaarvoice_reviews\Controller\BazaarvoiceReviewsViewReviewsController::title',
      ), // Route requirements:
      array(
        '_permission' => 'access content',
        'node' => '\d+',
      ), array(
        'parameters' => array(
          'node' => array(
            'type' => 'bv_product_node',
          ),
        ),
      ));
    return $routes;
  }

}
